/* propertyaccessor.c generated by valac, the Vala compiler
 * generated from propertyaccessor.vala, do not modify */

/* propertyaccessor.vala
 *
 * Copyright (C) 2008-2011  Florian Brosch
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Florian Brosch <flo.brosch@gmail.com>
 */


#include <glib.h>
#include <glib-object.h>
#include "valadoc.h"
#include <stdlib.h>
#include <string.h>
#include <vala.h>

enum  {
	VALADOC_API_PROPERTY_ACCESSOR_0_PROPERTY,
	VALADOC_API_PROPERTY_ACCESSOR_NODE_TYPE_PROPERTY,
	VALADOC_API_PROPERTY_ACCESSOR_IS_CONSTRUCT_PROPERTY,
	VALADOC_API_PROPERTY_ACCESSOR_IS_SET_PROPERTY,
	VALADOC_API_PROPERTY_ACCESSOR_IS_GET_PROPERTY,
	VALADOC_API_PROPERTY_ACCESSOR_IS_OWNED_PROPERTY,
	VALADOC_API_PROPERTY_ACCESSOR_NUM_PROPERTIES
};
static GParamSpec* valadoc_api_property_accessor_properties[VALADOC_API_PROPERTY_ACCESSOR_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _valadoc_api_signature_builder_unref0(var) ((var == NULL) ? NULL : (var = (valadoc_api_signature_builder_unref (var), NULL)))

struct _ValadocApiPropertyAccessorPrivate {
	ValadocApiPropertyAccessorType type;
	ValadocApiOwnership ownership;
	gchar* cname;
};


static gint ValadocApiPropertyAccessor_private_offset;
static gpointer valadoc_api_property_accessor_parent_class = NULL;

static void valadoc_api_property_accessor_real_accept (ValadocApiNode* base,
                                                ValadocApiVisitor* visitor);
static ValadocContentInline* valadoc_api_property_accessor_real_build_signature (ValadocApiItem* base);
static void valadoc_api_property_accessor_finalize (GObject * obj);
static void _vala_valadoc_api_property_accessor_get_property (GObject * object,
                                                       guint property_id,
                                                       GValue * value,
                                                       GParamSpec * pspec);


static inline gpointer
valadoc_api_property_accessor_get_instance_private (ValadocApiPropertyAccessor* self)
{
	return G_STRUCT_MEMBER_P (self, ValadocApiPropertyAccessor_private_offset);
}


ValadocApiPropertyAccessor*
valadoc_api_property_accessor_construct (GType object_type,
                                         ValadocApiProperty* parent,
                                         ValadocApiSourceFile* file,
                                         const gchar* name,
                                         ValadocApiSymbolAccessibility accessibility,
                                         const gchar* cname,
                                         ValadocApiPropertyAccessorType type,
                                         ValadocApiOwnership ownership,
                                         ValaPropertyAccessor* data)
{
	ValadocApiPropertyAccessor * self = NULL;
	gchar* _tmp0_;
	g_return_val_if_fail (parent != NULL, NULL);
	g_return_val_if_fail (file != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	g_return_val_if_fail (data != NULL, NULL);
	self = (ValadocApiPropertyAccessor*) valadoc_api_symbol_construct (object_type, (ValadocApiNode*) parent, file, name, accessibility, (ValaSymbol*) data);
	self->priv->ownership = ownership;
	_tmp0_ = g_strdup (cname);
	_g_free0 (self->priv->cname);
	self->priv->cname = _tmp0_;
	self->priv->type = type;
	return self;
}


ValadocApiPropertyAccessor*
valadoc_api_property_accessor_new (ValadocApiProperty* parent,
                                   ValadocApiSourceFile* file,
                                   const gchar* name,
                                   ValadocApiSymbolAccessibility accessibility,
                                   const gchar* cname,
                                   ValadocApiPropertyAccessorType type,
                                   ValadocApiOwnership ownership,
                                   ValaPropertyAccessor* data)
{
	return valadoc_api_property_accessor_construct (VALADOC_API_TYPE_PROPERTY_ACCESSOR, parent, file, name, accessibility, cname, type, ownership, data);
}


/**
 * Returns the name of this property accessor as it is used in C.
 */
gchar*
valadoc_api_property_accessor_get_cname (ValadocApiPropertyAccessor* self)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->cname;
	_tmp1_ = g_strdup (_tmp0_);
	result = _tmp1_;
	return result;
}


/**
 * {@inheritDoc}
 */
static void
valadoc_api_property_accessor_real_accept (ValadocApiNode* base,
                                           ValadocApiVisitor* visitor)
{
	ValadocApiPropertyAccessor * self;
	self = (ValadocApiPropertyAccessor*) base;
	g_return_if_fail (visitor != NULL);
}


/**
 * {@inheritDoc}
 */
static ValadocContentInline*
valadoc_api_property_accessor_real_build_signature (ValadocApiItem* base)
{
	ValadocApiPropertyAccessor * self;
	ValadocContentInline* result = NULL;
	ValadocApiSignatureBuilder* signature = NULL;
	ValadocApiSignatureBuilder* _tmp0_;
	gboolean _tmp1_;
	ValadocApiItem* _tmp4_;
	ValadocApiItem* _tmp5_;
	ValadocApiSymbolAccessibility _tmp6_;
	ValadocApiSymbolAccessibility _tmp7_;
	ValadocApiSymbolAccessibility _tmp8_;
	ValadocApiSymbolAccessibility _tmp9_;
	gboolean _tmp14_ = FALSE;
	gboolean _tmp15_;
	gboolean _tmp16_;
	ValadocApiSignatureBuilder* _tmp31_;
	ValadocApiSignatureBuilder* _tmp32_;
	ValadocContentRun* _tmp33_;
	self = (ValadocApiPropertyAccessor*) base;
	_tmp0_ = valadoc_api_signature_builder_new ();
	signature = _tmp0_;
	_tmp1_ = ((ValadocApiNode*) self)->do_document;
	if (!_tmp1_) {
		ValadocApiSignatureBuilder* _tmp2_;
		ValadocContentRun* _tmp3_;
		_tmp2_ = signature;
		_tmp3_ = valadoc_api_signature_builder_get (_tmp2_);
		result = (ValadocContentInline*) _tmp3_;
		_valadoc_api_signature_builder_unref0 (signature);
		return result;
	}
	_tmp4_ = valadoc_api_item_get_parent ((ValadocApiItem*) self);
	_tmp5_ = _tmp4_;
	_tmp6_ = valadoc_api_symbol_get_accessibility ((ValadocApiSymbol*) G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, VALADOC_API_TYPE_PROPERTY, ValadocApiProperty));
	_tmp7_ = _tmp6_;
	_tmp8_ = valadoc_api_symbol_get_accessibility ((ValadocApiSymbol*) self);
	_tmp9_ = _tmp8_;
	if (_tmp7_ != _tmp9_) {
		ValadocApiSignatureBuilder* _tmp10_;
		ValadocApiSymbolAccessibility _tmp11_;
		ValadocApiSymbolAccessibility _tmp12_;
		const gchar* _tmp13_;
		_tmp10_ = signature;
		_tmp11_ = valadoc_api_symbol_get_accessibility ((ValadocApiSymbol*) self);
		_tmp12_ = _tmp11_;
		_tmp13_ = valadoc_api_symbol_accessibility_to_string (_tmp12_);
		valadoc_api_signature_builder_append_keyword (_tmp10_, _tmp13_, TRUE);
	}
	_tmp15_ = valadoc_api_property_accessor_get_is_set (self);
	_tmp16_ = _tmp15_;
	if (_tmp16_) {
		_tmp14_ = TRUE;
	} else {
		gboolean _tmp17_;
		gboolean _tmp18_;
		_tmp17_ = valadoc_api_property_accessor_get_is_construct (self);
		_tmp18_ = _tmp17_;
		_tmp14_ = _tmp18_;
	}
	if (_tmp14_) {
		gboolean _tmp19_;
		gboolean _tmp20_;
		gboolean _tmp22_;
		gboolean _tmp23_;
		_tmp19_ = valadoc_api_property_accessor_get_is_construct (self);
		_tmp20_ = _tmp19_;
		if (_tmp20_) {
			ValadocApiSignatureBuilder* _tmp21_;
			_tmp21_ = signature;
			valadoc_api_signature_builder_append_keyword (_tmp21_, "construct", TRUE);
		}
		_tmp22_ = valadoc_api_property_accessor_get_is_set (self);
		_tmp23_ = _tmp22_;
		if (_tmp23_) {
			ValadocApiSignatureBuilder* _tmp24_;
			_tmp24_ = signature;
			valadoc_api_signature_builder_append_keyword (_tmp24_, "set", TRUE);
		}
	} else {
		gboolean _tmp25_;
		gboolean _tmp26_;
		_tmp25_ = valadoc_api_property_accessor_get_is_get (self);
		_tmp26_ = _tmp25_;
		if (_tmp26_) {
			gboolean _tmp27_;
			gboolean _tmp28_;
			ValadocApiSignatureBuilder* _tmp30_;
			_tmp27_ = valadoc_api_property_accessor_get_is_owned (self);
			_tmp28_ = _tmp27_;
			if (_tmp28_) {
				ValadocApiSignatureBuilder* _tmp29_;
				_tmp29_ = signature;
				valadoc_api_signature_builder_append_keyword (_tmp29_, "owned", TRUE);
			}
			_tmp30_ = signature;
			valadoc_api_signature_builder_append_keyword (_tmp30_, "get", TRUE);
		}
	}
	_tmp31_ = signature;
	valadoc_api_signature_builder_append (_tmp31_, ";", FALSE);
	_tmp32_ = signature;
	_tmp33_ = valadoc_api_signature_builder_get (_tmp32_);
	result = (ValadocContentInline*) _tmp33_;
	_valadoc_api_signature_builder_unref0 (signature);
	return result;
}


static ValadocApiNodeType
valadoc_api_property_accessor_real_get_node_type (ValadocApiNode* base)
{
	ValadocApiNodeType result;
	ValadocApiPropertyAccessor* self;
	self = (ValadocApiPropertyAccessor*) base;
	result = VALADOC_API_NODE_TYPE_PROPERTY_ACCESSOR;
	return result;
}


gboolean
valadoc_api_property_accessor_get_is_construct (ValadocApiPropertyAccessor* self)
{
	gboolean result;
	ValadocApiPropertyAccessorType _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->type;
	result = (_tmp0_ & VALADOC_API_PROPERTY_ACCESSOR_TYPE_CONSTRUCT) != 0;
	return result;
}


gboolean
valadoc_api_property_accessor_get_is_set (ValadocApiPropertyAccessor* self)
{
	gboolean result;
	ValadocApiPropertyAccessorType _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->type;
	result = (_tmp0_ & VALADOC_API_PROPERTY_ACCESSOR_TYPE_SET) != 0;
	return result;
}


gboolean
valadoc_api_property_accessor_get_is_get (ValadocApiPropertyAccessor* self)
{
	gboolean result;
	ValadocApiPropertyAccessorType _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->type;
	result = (_tmp0_ & VALADOC_API_PROPERTY_ACCESSOR_TYPE_GET) != 0;
	return result;
}


gboolean
valadoc_api_property_accessor_get_is_owned (ValadocApiPropertyAccessor* self)
{
	gboolean result;
	ValadocApiOwnership _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->ownership;
	result = _tmp0_ == VALADOC_API_OWNERSHIP_OWNED;
	return result;
}


static void
valadoc_api_property_accessor_class_init (ValadocApiPropertyAccessorClass * klass)
{
	valadoc_api_property_accessor_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &ValadocApiPropertyAccessor_private_offset);
	((ValadocApiNodeClass *) klass)->accept = (void (*) (ValadocApiNode *, ValadocApiVisitor*)) valadoc_api_property_accessor_real_accept;
	((ValadocApiItemClass *) klass)->build_signature = (ValadocContentInline* (*) (ValadocApiItem *)) valadoc_api_property_accessor_real_build_signature;
	VALADOC_API_NODE_CLASS (klass)->get_node_type = valadoc_api_property_accessor_real_get_node_type;
	G_OBJECT_CLASS (klass)->get_property = _vala_valadoc_api_property_accessor_get_property;
	G_OBJECT_CLASS (klass)->finalize = valadoc_api_property_accessor_finalize;
	/**
	 * {@inheritDoc}
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALADOC_API_PROPERTY_ACCESSOR_NODE_TYPE_PROPERTY, valadoc_api_property_accessor_properties[VALADOC_API_PROPERTY_ACCESSOR_NODE_TYPE_PROPERTY] = g_param_spec_enum ("node-type", "node-type", "node-type", VALADOC_API_TYPE_NODE_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	/**
	 * Specifies whether this accessor may be used to construct the property.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALADOC_API_PROPERTY_ACCESSOR_IS_CONSTRUCT_PROPERTY, valadoc_api_property_accessor_properties[VALADOC_API_PROPERTY_ACCESSOR_IS_CONSTRUCT_PROPERTY] = g_param_spec_boolean ("is-construct", "is-construct", "is-construct", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	/**
	 * Specifies whether this accessor is a setter.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALADOC_API_PROPERTY_ACCESSOR_IS_SET_PROPERTY, valadoc_api_property_accessor_properties[VALADOC_API_PROPERTY_ACCESSOR_IS_SET_PROPERTY] = g_param_spec_boolean ("is-set", "is-set", "is-set", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	/**
	 * Specifies whether this accessor is a getter.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALADOC_API_PROPERTY_ACCESSOR_IS_GET_PROPERTY, valadoc_api_property_accessor_properties[VALADOC_API_PROPERTY_ACCESSOR_IS_GET_PROPERTY] = g_param_spec_boolean ("is-get", "is-get", "is-get", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	/**
	 * Specifies whether the property is owned.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALADOC_API_PROPERTY_ACCESSOR_IS_OWNED_PROPERTY, valadoc_api_property_accessor_properties[VALADOC_API_PROPERTY_ACCESSOR_IS_OWNED_PROPERTY] = g_param_spec_boolean ("is-owned", "is-owned", "is-owned", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}


static void
valadoc_api_property_accessor_instance_init (ValadocApiPropertyAccessor * self)
{
	self->priv = valadoc_api_property_accessor_get_instance_private (self);
}


static void
valadoc_api_property_accessor_finalize (GObject * obj)
{
	ValadocApiPropertyAccessor * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALADOC_API_TYPE_PROPERTY_ACCESSOR, ValadocApiPropertyAccessor);
	_g_free0 (self->priv->cname);
	G_OBJECT_CLASS (valadoc_api_property_accessor_parent_class)->finalize (obj);
}


/**
 * Represents a get or set accessor of a property.
 */
GType
valadoc_api_property_accessor_get_type (void)
{
	static volatile gsize valadoc_api_property_accessor_type_id__volatile = 0;
	if (g_once_init_enter (&valadoc_api_property_accessor_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ValadocApiPropertyAccessorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valadoc_api_property_accessor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValadocApiPropertyAccessor), 0, (GInstanceInitFunc) valadoc_api_property_accessor_instance_init, NULL };
		GType valadoc_api_property_accessor_type_id;
		valadoc_api_property_accessor_type_id = g_type_register_static (VALADOC_API_TYPE_SYMBOL, "ValadocApiPropertyAccessor", &g_define_type_info, 0);
		ValadocApiPropertyAccessor_private_offset = g_type_add_instance_private (valadoc_api_property_accessor_type_id, sizeof (ValadocApiPropertyAccessorPrivate));
		g_once_init_leave (&valadoc_api_property_accessor_type_id__volatile, valadoc_api_property_accessor_type_id);
	}
	return valadoc_api_property_accessor_type_id__volatile;
}


static void
_vala_valadoc_api_property_accessor_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec)
{
	ValadocApiPropertyAccessor * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VALADOC_API_TYPE_PROPERTY_ACCESSOR, ValadocApiPropertyAccessor);
	switch (property_id) {
		case VALADOC_API_PROPERTY_ACCESSOR_NODE_TYPE_PROPERTY:
		g_value_set_enum (value, valadoc_api_node_get_node_type ((ValadocApiNode*) self));
		break;
		case VALADOC_API_PROPERTY_ACCESSOR_IS_CONSTRUCT_PROPERTY:
		g_value_set_boolean (value, valadoc_api_property_accessor_get_is_construct (self));
		break;
		case VALADOC_API_PROPERTY_ACCESSOR_IS_SET_PROPERTY:
		g_value_set_boolean (value, valadoc_api_property_accessor_get_is_set (self));
		break;
		case VALADOC_API_PROPERTY_ACCESSOR_IS_GET_PROPERTY:
		g_value_set_boolean (value, valadoc_api_property_accessor_get_is_get (self));
		break;
		case VALADOC_API_PROPERTY_ACCESSOR_IS_OWNED_PROPERTY:
		g_value_set_boolean (value, valadoc_api_property_accessor_get_is_owned (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



